<HTML>
  <HEAD>

<meta http-equiv="Pragma" content="no-cache">
<meta http-equiv='Content-Type' content='text/html; charset=UTF-8'>
<META HTTP-EQUIV="Expires" CONTENT="-1">


<TITLE>Integration Server -- Keystore Management -- Keystore/Truststore</TITLE>
<LINK REL="stylesheet" TYPE="text/css" HREF="webMethods.css">
%ifvar webMethods-wM-AdminUI%
  <link rel="stylesheet" TYPE="text/css" HREF="webMethods-wM-AdminUI.css"></link>
  <script>webMethods_wM_AdminUI = 'true';</script>
%endif%
<SCRIPT SRC="webMethods.js"></SCRIPT>

<SCRIPT LANGUAGE="JavaScript">
      var isLocationChanged = 'false';

      function confirmAdd () {
	      	var type="%value type encode(javascript)%";	     
            var mode=document.addform.mode.value;
    
        if(mode.search('edit_')==-1){
            if(!checkLegalName(document.addform.keyStoreName, "Alias")){
                return false;
            }
            if (!validateFields()) 
                {
                    alert(errorMsg);
                    return false;
                }  
            
            if (!isKeyStorePasswordValid())
                {
                    alert("Please verify the keystore password");
                    return false;
                }

                var storeName=document.addform.keyStoreName.value;
                if (isDuplicateAlias(storeName)){
                    var msg="Do you want to overwrite existing alias " + storeName + "?";
                    if(!confirm(msg))
                        return false;
                }
            }

            if(type=='key' && mode=='add'){
                document.addform.mode.value='edit_add';
            }
            else if(type=='key' && mode=='edit'){
                document.addform.mode.value='edit_edit';
            }
            
            document.addform.submit();
            return true;
      }
      
      var errorMsg = "";
      function validateFields()
      {
	  	var type="%value type encode(javascript)%";
         if ( document.addform.keyStoreName.value == "")
         {
            errorMsg = "Please enter the Alias";
            return false;
         }

        // For Non HSM based keystore, location is must
         if(type == 'key' && document.addform.isHsm[1].checked == true) 
         {
            if ( document.addform.keyStoreLocation.value == "" ) 
            {
                errorMsg = "Please enter the location";
                return false;
            }
         }

         /*
         var ksType=document.addform.keyStoreType.value;

        if (document.addform.allowNullLocation.checked == false && document.addform.keyStoreLocation.value == "")
         {
            errorMsg = "Please enter the Location";
            return false;
         }
         
         if (document.addform.allowNullLocation.checked == true)  {
            document.addform.nullKSLocation.value = true;
        }
        else {
            document.addform.nullKSLocation.value = false;
        }

         if (document.addform.allowNullPasswd.checked == false && document.addform.keyStorePassword.value == "")
         {
            errorMsg = "Please enter the Password";
            return false;
         }
         
         if (document.addform.allowNullPasswd.checked == true)  {
            document.addform.nullKSPasswd.value = true;
        }
        else {
            document.addform.nullKSPasswd.value = false;
        }
        */
        return true;                
      }
      
      
      function checkLegalName(field, fieldName)
          {
            var name = field.value;
            var illegalChars = "- #&@^!%*:$./\\`;,~+=)(|}{][><\"?";

            for (var i=0; i<illegalChars.length; i++)
            {
              if (name.indexOf(illegalChars.charAt(i)) >= 0)
              {
                alert (fieldName + " contains illegal character: '" + illegalChars.charAt(i) + "'");
                return false;
              }
            }
            return true;
          }
      
      function confirmEdit() {
      var type="%value type encode(javascript)%";
            if(type == 'key' && isLocationChanged == 'true') {
                document.addform.keyStoreLocationChanged.value=true;
                if(! confirm('Changing the keystore location will cause older key aliases to be removed from the configuration. OK to change it?')) {
                    return false;
                }
            }
            var mode=document.addform.mode.value;
            if(mode.search("edit_")==-1)
        {
            if ( !validateFields()) 
                {
                    alert(errorMsg);
                    return false;
                }                 
                if (!isKeyStorePasswordValid())
                {
                    alert("Please verify the keystore password");
                    return false;
                }
        }
            if (!isAliasPasswordsValid())
            {
                var aliases = "";
                for (var i = 0; i < invalidAlias.length; i++)
                {
                    aliases = aliases + invalidAlias[i];
                    if (i+1 < invalidAlias.length)
                        aliases = aliases + ",";
                }
                alert("Please verify the password(s) for the following aliases:\n " + aliases);
                return false;
            }
            if(type=='key' && mode=='add'){
                document.addform.mode.value='edit_add';
            }
            else if(type=='key' && mode=='edit'){
                document.addform.mode.value='edit_edit';
            }
            
            document.addform.submit();
            return true;
      }
      
      function isDuplicateAlias(alias){
      
          for(var i=0;i<existingStoreAliases.length;i++){
            if(existingStoreAliases[i].toLowerCase()==alias.toLowerCase()){
                return true;
            }
          }
          
          return false;
      }

      var invalidAlias = null;
      function isAliasPasswordsValid()
      {
            invalidAlias = new Array();         
            var aliases         = document.getElementsByName('pkAliases');
            var aliasPasswds    = document.getElementsByName('pkPasswords');
            var reAliasPasswds  = document.getElementsByName('re_pkPasswords');
            
            var idx = 0;
            for(var i =0; i <aliasPasswds.length; i++)
            {
                if (aliasPasswds[i].value != reAliasPasswds[i].value)
                    invalidAlias[idx++] = aliases[i].value;
            }
            if (idx != 0)
                return false;
            else
                return true;
      }

      function isKeyStorePasswordValid()
      { 
         if ( document.addform.keyStorePassword.value != document.addform.retype_keyStorePassword.value )
            return false;
         
         return true
      }
      
      var hiddenOptions = new Array();   
      var aliasList = new Array();
      var configuredAliases = new Array();
      var existingStoreAliases=new Array();
      var selectedKS="JKS";
      var selectedPS="Sun";
      var nullPKpasswds = new Array();

      function setupKeystoreData()
      {
            var idx = 0;
            %ifvar mode matches('edit_*')%
                %invoke wm.server.security.keystore:loadStore%
                    %ifvar type equals('key')%
                        %ifvar isError equals('true')%
                            %rename oldMode mode -copy%
                        %endif%
                    %endif%
                    %scope keyStore%
							selectedKS = "%value keyStoreType encode(javascript)%";
							selectedPS = "%value keyStoreProvider encode(javascript)%";
                            %loop configuredKeyAliases%
					 			aliasArray[idx] = "%value keyAlias encode(javascript)%";
					 			configuredAliases[idx] = "%value keyAlias encode(javascript)%";
                                bitArray[idx] = 0;
								nullPKpasswds[idx] = "%value nullPassword encode(javascript)%";
                                idx++;
                            %endloop%
                            
                            %loop nonConfiguredKeyAliases%
						 		aliasArray[idx] = "%value encode(javascript)%";
                                bitArray[idx] = 0;
                                nullPKpasswds[idx] = "false";
                                idx++;
                            %endloop%
                    %endscope%
                %endinvoke%                              
            %endif%
            
            %ifvar mode matches('edit_*')%
            %else%
                var ks = document.addform.keyStoreType.options;
                %ifvar type equals('key')%
                        %scope param(type='key')%
                            %invoke wm.server.security.keystore:listKeyStoreTypes%  
                               %loop keyProviderList%
                                    ks.length=ks.length+1;
						       		ks[ks.length-1] = new Option("%value keyStoreType encode(javascript)%","%value keyStoreType encode(javascript)%");
                                
                                    var providers = new Array();                        
                                    %loop providerList%
					       				providers["%value $index encode(javascript)%"] = new Option("%value provider encode(javascript)%","%value provider encode(javascript)%");		
                                    %endloop%
                                    
                                    hiddenOptions[ks.length-1] = providers;
                               %endloop%
                            %endinvoke%
                        %endscope%
                  %else%
                            %scope param(type='trust')%
                                %invoke wm.server.security.keystore:listKeyStoreTypes%  
                                   %loop keyProviderList%
                                        ks.length=ks.length+1;
							       		ks[ks.length-1] = new Option("%value keyStoreType encode(javascript)%","%value keyStoreType encode(javascript)%");
                                    
                                        var providers = new Array();                        
                                        %loop providerList%
						       				providers["%value $index encode(javascript)%"] = new Option("%value provider encode(javascript)%","%value provider encode(javascript)%");		
                                        %endloop%
                                        
                                        hiddenOptions[ks.length-1] = providers;
                                   %endloop%
                                %endinvoke%
                            %endscope%
                  %endif%
                                %ifvar mode equals('edit')%
                  					%invoke wm.server.security.keystore:getKeyStore%
                  						%scope keyStore%
                  							selectedKS = "%value keyStoreType encode(html)%";
                  						%endscope%
                  					%endinvoke%
                  				%endif%
                                
                                var ks = document.addform.keyStoreType.options;
                                var position=0;
                                for(var i=0; i<ks.length; i++) {
                                        if(selectedKS == ks[i].value) {
                                            ks[i].selected = true;
                                            position++;
                                        }
                                }
                                changeval();
                                var ps = document.addform.keyStoreProvider.options;
                                for(var i=0; i<ps.length; i++) {
                                        if(selectedPS == ps[i].value) {
                                            ps[i].selected = true;
                                        }
                                }
            %endif%
            
            if(idx>0){
                document.addform.configuredAliases.value = configuredAliases;
                document.addform.bitarray.value = bitArray;
                document.addform.nullPKpasswds.value = nullPKpasswds;
            }
            
            %ifvar isError equals('true')%
                var tempmode = document.addform.oldMode.value;
                if(tempmode != '')
                    document.addform.mode.value=tempmode;
            %endif%

            if(document.addform.mode.value=="add"){
				if("%value type encode(javascript)%" == "key"){
                  %invoke wm.server.security.keystore:listKeyStoreAliases%
                     %loop keyStoreAliasNames%
                        existingStoreAliases.length=existingStoreAliases.length+1;
				  		existingStoreAliases[existingStoreAliases.length-1] = "%value encode(javascript)%";
                     %endloop%
                  %endinvoke%
                }
                else{
                    %invoke wm.server.security.keystore:listTrustStoreAliases%
                       %loop trustStoreAliasNames%
                            existingStoreAliases.length=existingStoreAliases.length+1;
				  		    existingStoreAliases[existingStoreAliases.length-1]="%value encode(javascript)%";
                        %endloop%
                    %endinvoke%
                }
            }
        
            return true;
       }
       
       function changeval() {
            
            var ks = document.addform.keyStoreType.options;
            var selectedKS = document.addform.keyStoreType.value;
            
            for(var i=0; i<ks.length; i++) {
                if(selectedKS == ks[i].value) {
                    var providers = hiddenOptions[i];
                    document.addform.keyStoreProvider.options.length = providers.length;
                    for(var j=0;j<providers.length;j++) {
                        document.addform.keyStoreProvider.options[j] = providers[j];
                    }
                }
            }
        }
        var bitArray = new Array();
        var aliasArray = new Array();
        
        function setNullPassword(alias, checkboxObj)
        {
            for (var i = 0; i < aliasArray.length; i++)
            {
                if (aliasArray[i] == alias)
                {
                    if ( checkboxObj.checked == true) {
                        nullPKpasswds[i] = "true";
                    }
                    else
                    {
                        nullPKpasswds[i] = "false";
                    }
                }
            }
            document.addform.aliasarray.value = aliasArray;
            document.addform.nullPKpasswds.value = nullPKpasswds;
        }

        function setPasswdChanged(alias)
        {
            for (var i = 0; i < aliasArray.length; i++)
            {
                if (aliasArray[i] == alias)
                {
                    bitArray[i] = 1;
                }
            }
            document.addform.aliasarray.value = aliasArray;
            document.addform.bitarray.value = bitArray;
        }
        
        function confirmLocationChange(){
            isLocationChanged = 'true';
        }
    
  </SCRIPT>
    <base target="_self">
    <style>
      .listbox  { width: 100%; }
    </style>
  </HEAD>

            %ifvar mode equals('edit')%
                        %ifvar type equals('key')%
                            <BODY onLoad="setupKeystoreData();setNavigation('security-keystoremgt-keystore.dsp', 'doc/OnlineHelp/wwhelp.htm?context=is_help&topic=IS_Security_EditKeystoreAliasScrn');">
                        %else%
                            <BODY onLoad="setupKeystoreData();setNavigation('security-keystoremgt-keystore.dsp', 'doc/OnlineHelp/wwhelp.htm?context=is_help&topic=IS_Security_EditTruststoreAliasScrn');">         
                        %endif% 
            %else%
                %ifvar mode equals('view')%
                        %ifvar type equals('key')%
                            <BODY onLoad="setNavigation('security-keystoremgt-keystore.dsp', 'doc/OnlineHelp/wwhelp.htm?context=is_help&topic=IS_Security_ViewKeystoreAliasScrn');">
                        %else%
                            <BODY onLoad="setNavigation('security-keystoremgt-keystore.dsp', 'doc/OnlineHelp/wwhelp.htm?context=is_help&topic=IS_Security_ViewTruststoreAliasScrn');">
                        %endif%
                    
                %else%
                        %ifvar type equals('key')%
                            %ifvar mode equals('edit_edit')%
                                <BODY onLoad="setupKeystoreData();setNavigation('security-keystoremgt-keystore.dsp', 'doc/OnlineHelp/wwhelp.htm?context=is_help&topic=IS_Security_EditKeystoreAliasScrn');">
                            %else%
                                <BODY onLoad="setupKeystoreData();setNavigation('security-keystoremgt-keystore.dsp', 'doc/OnlineHelp/wwhelp.htm?context=is_help&topic=IS_Security_CreateKeystoreAliasScrn');">
                            %endif%
                        %else%
                            <BODY onLoad="setupKeystoreData();setNavigation('security-keystoremgt-keystore.dsp', 'doc/OnlineHelp/wwhelp.htm?context=is_help&topic=IS_Security_CreateTruststoreAliasScrn');">
                        %endif%
                %endif%
            %endif%
  
  
    <TABLE width="100%">
                        
      <TR>
        <TD colspan=2 class="breadcrumb">
            Security &gt;
            Keystore &gt;
            
            %ifvar mode equals('edit')%
                        %ifvar type equals('key')%
                            Edit Keystore Alias
                        %else%
                            Edit Truststore Alias         
                        %endif% 
            %else%
                %ifvar mode equals('view')%
                        %ifvar type equals('key')%
                            View Keystore Alias
                        %else%
                            View Truststore Alias         
                        %endif%
                    
                %else%
                        %ifvar type equals('key')%
                            %ifvar mode equals('edit_edit')%
                                Edit Keystore Alias
                            %else%
                                Create Keystore Alias
                            %endif%
                        %else%
                            Create Truststore Alias         
                        %endif%
                %endif%
            %endif%
        </TD>
        
      </TR>
        %ifvar isError equals('true')%
            <tr><td colspan="2"></td></tr>
		  	<TR><TD class="message" colspan="2">%value message encode(html)%</TD></TR>
            <TR><TD colspan="2"><IMG SRC="images/blank.gif" width=10 height=10 border=0></TD></TR>
        %else%
            %ifvar isWarning equals('true')%
                <tr><td colspan="2"></td></tr>
		  		<TR><TD class="message" colspan="2">%value message encode(html)%</TD></TR>
                <TR><TD colspan="2"><IMG SRC="images/blank.gif" width=10 height=10 border=0></TD></TR>
            %endif%
        %endif%
      
      <TR>
        <TD colspan=2>
          <ul class="listitems">
		    <script>
			createForm("htmlform_security_keystoremgt", "security-keystoremgt.dsp", "POST", "BODY");
			</script>
            <li>
			<script>getURL("security-keystoremgt.dsp","javascript:document.htmlform_security_keystoremgt.submit();","Return to Keystore");</script>
			</li>
            %ifvar mode equals('view')%
				<script>
				createForm("htmlform_security_keystoremgt_keystore", "security-keystoremgt-keystore.dsp", "POST", "BODY");
				setFormProperty("htmlform_security_keystoremgt_keystore", "mode", "edit");
				setFormProperty("htmlform_security_keystoremgt_keystore", "keyStoreName", "%value keyStoreName%");
				setFormProperty("htmlform_security_keystoremgt_keystore", "type", "%value type%");
				</script>
                <li>
				<script>getURL("security-keystoremgt-keystore.dsp?mode=edit&keyStoreName=%value keyStoreName encode(url)%&type=%value type encode(url)%","javascript:document.htmlform_security_keystoremgt_keystore.submit();","Edit %ifvar type equals('key')%Keystore Alias%else%Truststore Alias%endif%");</script>
                </LI>            
            %endif%
          </UL>
        </TD>
      </TR>

      <TR>
        <TD>
        %ifvar mode equals('view')%  <!-- View keystore/truststore alias block-->
           <TABLE class="tableView">
            %invoke wm.server.security.keystore:getKeyStore%
                %scope keyStore%
                  <TR>
                    %ifvar ../type equals('key')%
                        <TD colspan="2" class="heading">Keystore Properties</TD>
                     %else%
                         <TD colspan="2" class="heading">Truststore Properties</TD>
                     %endif%
                  </TR>
                  <TR>
                    <TD class="oddrow"><B>Alias</B></TD>
		            <TD class="oddrow-l"><B>%value keyStoreName encode(html)%</B></TD>
                  </TR>
                  <TR>
                    <TD class="evenrow"><B>Description(optional)</B></TD>
		            <TD class="evenrow-l">%value keyStoreDescription encode(html)%</TD>
                  </TR>               
                  <TR>
                    <TD class="oddrow"><B>Type</B></TD>
		            <TD class="oddrow-l">%value keyStoreType encode(html)%</TD>
                  </TR>
                  <TR>
                    <TD class="evenrow"><B>Provider</B></TD>
		            <TD class="evenrow-l">%value keyStoreProvider encode(html)%</TD>
                  </TR>
                  <TR>
                    <TD class="oddrow"><B>Location</B></TD>
		            <TD class="oddrow-l">%value keyStoreLocation encode(html)%</TD>
                  </TR>
                   %ifvar ../type equals('key')%
                  <tr>
                <td class="evenrow"><B>HSM Based Keystore</B></td>
				<td class="evenrow-l">%value isHsm encode(html)%</td>
                      </tr>             
                  %endif%  
              %ifvar ../type equals('key')%
                 <TR>
                        <TD class="oddrow-l" valign="top"><B>Configured Key Aliases</B></TD>
                        <TD class="oddrow-l">   
                            <TABLE> 
                                %loop configuredKeyAliases%
                                    <TR>
				            			<TD>%value keyAlias encode(html)%</TD>
                                    </TR>
                                %endloop%
                            </TABLE>
                        </TD>
                      </TR>
                  %else%
				  <TR>
                    <TD class="evenrow"><B>Secondary Truststore(optional)</B></TD>
		            <TD class="evenrow-l">%value secondaryTS encode(html)%</TD>
                <TR>
                    <TD class="oddrow" valign="top"><B>Certificate Aliases</B></TD>
                    <TD class="oddrow-l">
                        <TABLE>
                                %loop certficateAliases%
                                    <TR>
				            			<TD>%value encode(html)%</TD>
                                    </TR>
                                %endloop%
                            </TABLE>
                    </TD>
                </TR>
                  %endif%
                %endscope%
            %endinvoke%   
            </TABLE> 
            <BR>
            <TABLE class="tableView" width=100%>
                %ifvar errorMessage equals('')%
                %else%
                    <TR>
                    <TD colspan="5" class="heading">Load Error</TD>
                </TR>
					<TD class="oddrow-l">%value errorMessage encode(html)%</TD>
                %endif%
            </TABLE>
        %else%
            <TABLE class="tableView">
            <TR>
                    %ifvar type equals('key')%
                        <TD colspan="2" class="heading">Keystore Properties</TD>
                     %else%
                         <TD colspan="2" class="heading">Truststore Properties</TD>
                     %endif%
             </TR>
            <FORM NAME="addform" ACTION=
                                        %ifvar type equals('key')% 
                                            %ifvar mode matches('edit_*')%
                                                "security-keystoremgt.dsp"
                                            %else%
                                                "security-keystoremgt-keystore.dsp"
                                            %endif%
                                        %else%
                                            "security-keystoremgt.dsp"
                                        %endif%
                                         METHOD="POST">
                                         
                    %ifvar webMethods-wM-AdminUI% <input type="hidden" name="webMethods-wM-AdminUI" value="true"> %endif%
                    <input type="hidden" name="aliasarray" value="">
                    <input type="hidden" name="bitarray" value="">                  
                    <input type="hidden" name="configuredAliases" value="">
                <input type="hidden" name="nullKSPasswd">
                <input type="hidden" name="nullKSLocation">
                <input type="hidden" name="nullPKpasswds" value="">
                                        
            %ifvar mode matches('edit*')% <!-- Edit keystore/truststore alias block-->
                %ifvar mode equals('edit')% <!-- Edit keystore/truststore alias block-->
                        %invoke wm.server.security.keystore:getKeyStore%
                        %scope keyStore%
                        <TR>
				        	<TD class="oddrow"><label for="ksname">Alias</label></TD>
                            <TD class="oddrow-l">
				          	<B>%value keyStoreName encode(html)%</B>
				          	<INPUT id="ksname" TYPE="hidden" NAME="keyStoreName" VALUE="%value keyStoreName encode(htmlattr)%"> 
                            </TD>
                        </TR>
                        <TR>
				        	<TD class="evenrow"><label for="desc">Description(optional)</label></TD>
				          	<TD class="evenrow-l"><INPUT id="desc" NAME="keyStoreDescription" VALUE="%value keyStoreDescription encode(htmlattr)%"> </TD>
                        </TR>
                        <TR>
					        <TD class="oddrow"><label for="type">Type</label></TD>
					        <TD class="oddrow-l"><SELECT id="type" NAME="keyStoreType" class="listbox" onchange="changeval()"></SELECT></TD>		
                        </TR>
                        <TR>
					        <TD class="evenrow"><label for="provider">Provider</label></TD>
					       	<TD class="evenrow-l"><SELECT id="provider" class="listbox" NAME="keyStoreProvider"></SELECT></TD>
                        </TR>
                        <TR>
					        <TD class="oddrow"><label for="loc">Location</label></TD>
                            <TD class="oddrow-l">
							<INPUT size="40" id="loc" NAME="keyStoreLocation" VALUE="%value keyStoreLocation encode(htmlattr)%" onChange="confirmLocationChange();">
                            <INPUT TYPE="hidden" NAME="keyStoreLocationChanged" VALUE="false">
                            </TD>
                        </TR>                 
                        <TR>
				           	<TD class="evenrow"><label for="pwd">Password </label></TD>
                            <TD class="evenrow-l">
                                %ifvar nullKSPassword equals('true')%
					           		<INPUT TYPE="password" id="pwd" NAME="keyStorePassword" autocomplete="off" VALUE="" onChange="document.addform.keyStorePasswordChanged.value=true;"/>
                            %else%
					           		<INPUT TYPE="password" id="pwd" NAME="keyStorePassword" autocomplete="off"  VALUE="******" onChange="document.addform.keyStorePasswordChanged.value=true;"/>
                            %endif%
				           		<INPUT id="pwd" TYPE="hidden" NAME="keyStorePasswordChanged" VALUE="false">
                            </TD>
                        </TR>
                        <TR>
				            <TD class="oddrow"><label for="rpwd">Re-type Password</label> </TD>
                         %ifvar nullKSPassword equals('true')%
					            <TD class="oddrow-l"><INPUT id="rpwd" TYPE="password" NAME="retype_keyStorePassword"  autocomplete="off" VALUE=""/></TD>
                         %else%
						    <TD class="oddrow-l"><INPUT id="rpwd" TYPE="password" NAME="retype_keyStorePassword"  autocomplete="off" VALUE="******"/></TD>
                         %endif%
                        </TR>
                        <TR>
				        	<TD class="evenrow"><label for="secondaryTS">Secondary Truststore(optional)</label></TD>
				          	<TD class="evenrow-l">
							<select name="secondaryTS" id="secondaryTS">
								%invoke wm.server.security.keystore:listTrustStores%
                                    <option name="" value=""></option>
                                %loop trustStores%
                                    %ifvar isLoaded equals('true')%
										<option name="%value keyStoreName encode(htmlattr)%" value="%value keyStoreName encode(htmlattr)%" %ifvar keyStoreName vequals(../secondaryTS)%selected%endif%>%value keyStoreName encode(html)%</option>
                                    %endif%
								%endloop%
								%endinvoke%
                            </select>
                        </TR>    

                        %ifvar ../type equals('key')%
                        <tr>
                            <td class="oddrow">HSM Based Keystore</td>
                            <td class="oddrow-l">
                                %ifvar isHsm equals('true')%
									<INPUT TYPE="radio" name="isHsm" id="isHsm1"  VALUE="true" checked><label for="isHsm1">True</label></INPUT>
							        <INPUT TYPE="radio" name="isHsm" id="isHsm2"  VALUE="false"><label for="isHsm2">False</label></INPUT>
                                %else%
									<INPUT TYPE="radio" name="isHsm" id="isHsm1"  VALUE="true" ><label for="isHsm1">True</label></INPUT>
							        <INPUT TYPE="radio" name="isHsm" id="isHsm2"  VALUE="false" checked><label for="isHsm2">False</label></INPUT>
                                %endif%
                            </td>
                        </tr>   
                        %endif%
                        <TR>
                            <TD><IMG SRC="images/blank.gif" width=10 height=10 border=0></TD>
                        </TR>
                    %endscope%              
                    %endinvoke%
                %else% <!-- edit_add/edit_edit start-->
                        %invoke wm.server.security.keystore:loadStore%
                    %scope keyStore%
                    <TR>
			        	<TD class="oddrow"><B><label for="ksname">Alias</label></B></TD>
                        <TD class="oddrow-l">
			        	%value keyStoreName encode(html)%
			          	<INPUT TYPE="hidden" id="ksname" NAME="keyStoreName" VALUE="%value keyStoreName encode(htmlattr)%"> 
                        </TD>
                    </TR>
                    <TR>
			        	<TD class="evenrow"><B><label for="desc">Description(optional)</label></B></TD>
                        <TD class="evenrow-l">
			          	%value keyStoreDescription encode(html)%
			          	<INPUT TYPE="hidden" id="desc" NAME="keyStoreDescription" VALUE="%value keyStoreDescription encode(htmlattr)%"> 
                        </TD>
                    </TR>
                    <TR>
				        <TD class="oddrow"><B><label for="type">Type</label></B></TD>
                        <TD class="oddrow-l">
				        %value keyStoreType encode(html)%
				        <INPUT TYPE="hidden" id="type" NAME="keyStoreType" VALUE="%value keyStoreType encode(htmlattr)%"> 
                        <!-- <SELECT NAME="keyStoreType" class="listbox" onchange="changeval()"></SELECT> -->
                        </TD>       
                    </TR>
                    <TR>
				        <TD class="evenrow"><B><label for="provider">Provider</label></B></TD>
                        <TD class="evenrow-l">
				       	%value keyStoreProvider encode(html)%
				       	<INPUT TYPE="hidden" id="provider" NAME="keyStoreProvider" VALUE="%value keyStoreProvider encode(htmlattr)%"> 
                        <!-- <SELECT class="listbox" NAME="keyStoreProvider"></SELECT> -->
                        </TD>
                    </TR>
                    <TR>
				        <TD class="oddrow"><B><label for="loc">Location</label><B></TD>
                        <TD class="oddrow-l">
				    	%value keyStoreLocation encode(html)%
				    	<INPUT TYPE="hidden" id="loc" NAME="keyStoreLocation" VALUE="%value keyStoreLocation encode(htmlattr)%" onChange="confirmLocationChange();"></TD>
				    	<INPUT TYPE="hidden" NAME="keyStoreLocationChanged" VALUE="%value keyStoreLocationChanged encode(htmlattr)%">
                    </TR>
			    	<INPUT TYPE="hidden" NAME="handle" VALUE="%value handle encode(htmlattr)%">
			    	<INPUT TYPE="hidden" NAME="keyStorePasswordChanged" VALUE="%value keyStorePasswordChanged encode(htmlattr)%">
                    <tr>
                        <td class="evenrow"><B>HSM Based Keystore</B></td>
                        <td class="evenrow-l">
                            %ifvar isHsm equals('true')%
                                true
                            %else%
                                false
                            %endif%
							<INPUT TYPE="hidden" NAME="isHsm" VALUE="%value isHsm encode(htmlattr)%">
                        </td>
                    </tr>   
                    <TR>
                        <TD><IMG SRC="images/blank.gif" width=10 height=10 border=0></TD>
                    </TR>
                    %ifvar ../type equals('key')%
                               
                        %ifvar configuredKeyAliases -isnull%
                                %ifvar nonConfiguredKeyAliases -isnull%
                                
                                %else%
                                    %ifvar nonConfiguredKeyAliases -notempty%
                                    <TR>
                                                <TD colspan="2" class="heading" valign="top"><B>Key Aliases</B></TD>
                                        </TR>

                                    <TR>   
                                        <TD class="oddrow">Alias</TD>
                                        <TD class="oddrow-l" hAlign="left">
                                            <table width="100%">
                                                <tr>
                                                    <td class="oddrow-l" width="50%">Password</td>
							          				<td class="oddrow-l" width="50%"><label for="rpwd">Re-type Password</label></td>
												<td class="oddrow-l" width="50%">Null</td>
                                                </tr>
                                            </table>
                                        </TD>
                                    </TR>
                                    %else%
                                                                    
                                    %endif% 
                                %endif%
                        %else%
                                %ifvar configuredKeyAliases -notempty%
                                <TR>
                                    <TD colspan="2" class="heading" valign="top"><B>Key Aliases</B></TD>
                                </TR>

                                <TR>   
                                    <TD class="oddrow">Alias</TD>
                                    <TD class="oddrow-l" hAlign="left">
                                        <table width="100%">
                                            <tr>
                                                <td class="oddrow-l" width="50%">Password</td>
						          				<td class="oddrow-l" width="50%"><label for="rpwd">Re-type Password</label></td>
											<td class="oddrow-l" width="50%">Null</td>
                                            </tr>
                                        </table>
                                    </TD>
                                </TR>
                                %else%
                                    %ifvar nonConfiguredKeyAliases -isnull%
                                    %else%
                                        %ifvar nonConfiguredKeyAliases -notempty%
                                        <TR>
                                                    <TD colspan="2" class="heading" valign="top"><B>Key Aliases</B></TD>
                                            </TR>

                                            <TR>   
                                                <TD class="oddrow">Alias</TD>
                                                <TD class="oddrow-l" hAlign="left">
                                                    <table width="100%">
                                                        <tr>
                                                            <td class="oddrow-l" width="50%">Password</td>
									          				<td class="oddrow-l" width="50%"><label for="rpwd">Re-type Password</label></td>
														<td class="oddrow-l" width="50%">Null</td>
                                                        </tr>
                                                    </table>
                                                </TD>
                                            </TR>                               
                                        %endif% 
                                    %endif%                     
                                %endif%
                        %endif% 
                        
                        %loop configuredKeyAliases%
                              <TR>
							  	<script>writeTD("rowdata-r");</script><label for="%value keyAlias encode(htmlattr)%">%value keyAlias encode(html)%</label>
								  		<INPUT NAME="pkAliases" TYPE="hidden" value="%value keyAlias encode(htmlattr)%"></TD>
                                <script>writeTD("rowdata");</script>
                                        <table width="100%">
                                            <tr>
						          				<script>writeTD("rowdata");</script><INPUT TYPE="password" autocomplete="off" ID="%value keyAlias encode(htmlattr)%" %ifvar nullPassword equals('false')% value="******" %else% value="" %endif% NAME="pkPasswords"  onChange="setPasswdChanged(this.id);"/></td>
                                                <script>writeTD("rowdata");</script><INPUT TYPE="password"  id="rpwd" autocomplete="off" NAME="re_pkPasswords" %ifvar nullPassword equals('false')% value="******" %else% value="" %endif%/> </td>
											<script>writeTD("rowdata");</script><INPUT TYPE="checkbox" NAME="nullPKPassword" onchange="setNullPassword('%value keyAlias encode(htmlattr)%', this)" %ifvar nullPassword equals('true')% checked %endif%></td>
                                            </tr>
                                        </table>
                                 </TD>
                             </TR>
                             <script>swapRows();</script>
                        %endloop%
    
                        %loop nonConfiguredKeyAliases%
                            <TR>
								  	<script>writeTD("rowdata-r");</script><label for="%value encode(htmlattr)%">%value encode(html)%</label>
								  		<INPUT NAME="pkAliases" TYPE="hidden" value="%value encode(htmlattr)%"></TD>
                                    <script>writeTD("rowdata");</script>
                                        <table width="100%">
                                            <tr>
						          				<script>writeTD("rowdata");</script><INPUT TYPE="password" ID="%value encode(htmlattr)%" NAME="pkPasswords" autocomplete="off" VALUE="" onChange="setPasswdChanged(this.id);"/></td>
                                                <script>writeTD("rowdata");</script><INPUT TYPE="password" id="rpwd" NAME="re_pkPasswords" autocomplete="off" VALUE=""/></td>
											<script>writeTD("rowdata");</script><INPUT TYPE="checkbox" NAME="nullPKPassword" onchange="setNullPassword('%value encode(javascript)%', this)"></td>
                                            </tr>
                                        </table>
                                     </TD>
                            </TR>
                            <script>swapRows();</script>    
                        %endloop%
                      %endif%
                %endscope%              
                %endinvoke%
                %endif%<!-- edit_add/edit_edit end-->
            %else% <!-- Add keystore/truststore alias block-->
                <TR>
			        <TD class="oddrow"><label for="ksname">Alias</label></TD>
			        <TD class="oddrow-l"><INPUT id="ksname" NAME="keyStoreName" VALUE="%value keyStoreName encode(htmlattr)%"> </TD>
                </TR>
                <TR>
			       	<TD class="evenrow"><label for="desc">Description(optional)</label></TD>
			       	<TD class="evenrow-l"><INPUT id="desc" NAME="keyStoreDescription" VALUE="%value keyStoreDescription encode(htmlattr)%"> </TD>
                </TR>               
                <TR>
			        <TD class="oddrow"><label for="type">Type</label></TD>
			        <TD class="oddrow-l"><SELECT id="type" NAME="keyStoreType" class="listbox" onchange="changeval()"></SELECT></TD>		
                </TR>
                <TR>
			        <TD class="evenrow"><label for="provider">Provider</label></TD>
			       	<TD class="evenrow-l"><SELECT id="provider" class="listbox" NAME="keyStoreProvider"></SELECT></TD>
                </TR>
                <TR>
			        <TD class="oddrow"><label for="loc">Location</label></TD>
                    <TD class="oddrow-l">
					<INPUT size="40" id="loc" NAME="keyStoreLocation" VALUE="%value keyStoreLocation encode(htmlattr)%">
                </TD>
                
                </TR>                 
                <TR>
		           	<TD class="evenrow"><label for="pwd">Password </label></TD>
                    <TD class="evenrow-l">
		           		<INPUT id="pwd" TYPE="password" NAME="keyStorePassword" autocomplete="off" VALUE="%value keyStorePassword encode(htmlattr)%" />
			           	<INPUT id="pwd" TYPE="hidden" NAME="keyStorePasswordChanged" VALUE="true">
                    </TD>
                </TR>
            <TR>
		           	<TD class="oddrow"><label for="rpwd">Re-type Password</label></TD>
				<TD class="oddrow-l"><INPUT id="rpwd" TYPE="password" NAME="retype_keyStorePassword"  autocomplete="off" VALUE="%value retype_keyStorePassword encode(htmlattr)%"/></TD>
                </TR>
				<TR>
					<TD class="evenrow"><label for="secondaryTS">Secondary Truststore(optional)</label></TD>
					<TD class="evenrow-l">
					<select name="secondaryTS" id="secondaryTS">
						%invoke wm.server.security.keystore:listTrustStores%
							<option name="" value=""></option>
						%loop trustStores%
							%ifvar isLoaded equals('true')%
								<option name="%value keyStoreName encode(htmlattr)%" value="%value keyStoreName encode(htmlattr)%" %ifvar keyStoreName vequals(../secondaryTS)%selected%endif%>%value keyStoreName encode(html)%</option>
							%endif%
						%endloop%
						%endinvoke%
					</select>
				</TR> 
                %ifvar type equals('key')%
                <tr>
                    <td class="oddrow">HSM Based Keystore</td>
                    <td class="oddrow-l">                   
                        %ifvar isHsm equals('true')%
							<INPUT TYPE="radio" name="isHsm" id="isHsm1"  VALUE="true" checked><label for="isHsm1">True</label></INPUT>
					        <INPUT TYPE="radio" name="isHsm" id="isHsm2"  VALUE="false"><label for="isHsm2">False</label></INPUT>
                        %else%
							<INPUT TYPE="radio" name="isHsm" id="isHsm1"  VALUE="true" ><label for="isHsm1">True</label></INPUT>
					        <INPUT TYPE="radio" name="isHsm" id="isHsm2"  VALUE="false" checked><label for="isHsm2">False</label></INPUT>
                        %endif%
                    </td>
                 </tr>  
            %endif%
            %endif%
            <TR>
                <TD colspan=2 class="action">
                      <INPUT TYPE="hidden" NAME="args" VALUE="xxx">
                  %ifvar type equals('key')%
                     %ifvar mode matches('edit_*')%
		              <INPUT TYPE="hidden" NAME="mode" VALUE="%value mode encode(htmlattr)%">
		              <INPUT TYPE="hidden" NAME="oldkeyStoreName" VALUE="%value keyStoreName encode(htmlattr)%">
		              <INPUT TYPE="hidden" NAME="type" VALUE="%value type encode(htmlattr)%">
                      <INPUT type="button" value="Save Changes" onclick="return confirmEdit();">
                    %else%
                      %ifvar mode equals('edit')%
                            <INPUT TYPE="hidden" NAME="oldMode" VALUE="edit">
		              		 <INPUT TYPE="hidden" NAME="mode" VALUE="%value mode encode(htmlattr)%">
		              		<INPUT TYPE="hidden" NAME="type" VALUE="%value type encode(htmlattr)%">
                            <INPUT type="button" value="Submit" onclick="return confirmEdit();">
                      %else%
                            <INPUT TYPE="hidden" NAME="oldMode" VALUE="add">
		              		 <INPUT TYPE="hidden" NAME="mode" VALUE="%value mode encode(htmlattr)%">
		              		<INPUT TYPE="hidden" NAME="type" VALUE="%value type encode(htmlattr)%">
                            <INPUT type="button" value="Submit" onclick="return confirmAdd();">
                      %endif%
                      
                     
                      
                    %endif%
                  %else%
                    %ifvar mode equals('edit')%
                      <INPUT TYPE="hidden" NAME="mode" VALUE="edit">
		              <INPUT TYPE="hidden" NAME="oldkeyStoreName" VALUE="%value keyStoreName encode(htmlattr)%">
		              <INPUT TYPE="hidden" NAME="type" VALUE="%value type encode(htmlattr)%">
                      <INPUT type="button" value="Save Changes" onclick="return confirmEdit();">
                    %else%
                      <INPUT TYPE="hidden" NAME="mode" VALUE="add">
		              <INPUT TYPE="hidden" NAME="type" VALUE="%value type encode(htmlattr)%">
                      <INPUT type="button" value="Save Changes" onclick="return confirmAdd();">
                    %endif%
                 %endif%
                </TD>
            </TR>
            </FORM>
            </TABLE>
        
        </TD>
        </TR>
        %endif%
      </TABLE>
    </BODY>
  </HTML>
